package GUI;

import org.jdesktop.application.SingleFrameApplication;
import ScoreManagement.ScoreManagement;

/**
 * Handles application initialization/startup
 */
public class Application extends SingleFrameApplication {

    /**
     * Startup function called by main->launch
     * Initializes/loads global data structures and main menu
     */
    @Override
    protected void startup() {
	ScoreManagement.Init();
	Options.Init();
	show(new MainMenu(this));
    }

    /**
     * This method is to initialize the specified window by injecting resources.
     * Windows shown in our application come fully initialized from the GUI
     * builder, so this additional configuration is not needed.
     */
    @Override
    protected void configureWindow(java.awt.Window root) {
    }

    /**
     * A convenient static getter for the application instance.
     * @return the instance of Application
     */
    public static Application getApplication() {
	return Application.getInstance(Application.class);
    }

    /**
     * Application entry point
     * @param args Arguments passed on the command line
     */
    public static void main(String[] args) {
	launch(Application.class, args);
    }
}
