package GUI;
import org.jdesktop.application.SingleFrameApplication;
import org.jdesktop.application.FrameView;

/* GUI Main menu */
public class MainMenu extends FrameView {
    private int count = 0;
    /* Initializes a new instance of the main menu window */
    public MainMenu(SingleFrameApplication app) {
        super(app);
        initComponents();
        jToggleButton1.setVisible(false);
        jToggleButton2.setVisible(false);
        mainPanel.requestFocus();
    }

    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        mainPanel = new javax.swing.JPanel();
        labelLogo = new javax.swing.JLabel();
        PanelMenu = new javax.swing.JPanel();
        buttonStartSinglePlayer = new javax.swing.JButton();
        buttonOptions = new javax.swing.JButton();
        buttonHighscores = new javax.swing.JButton();
        buttonHelp = new javax.swing.JButton();
        buttonQuit = new javax.swing.JButton();
        jToggleButton1 = new javax.swing.JToggleButton();
        jToggleButton2 = new javax.swing.JToggleButton();

        org.jdesktop.application.ResourceMap resourceMap = org.jdesktop.application.Application.getInstance().getContext().getResourceMap(MainMenu.class);
        mainPanel.setBackground(resourceMap.getColor("mainPanel.background")); // NOI18N
        mainPanel.setCursor(new java.awt.Cursor(java.awt.Cursor.DEFAULT_CURSOR));
        mainPanel.setInheritsPopupMenu(true);
        mainPanel.setMaximumSize(new java.awt.Dimension(488, 507));
        mainPanel.setMinimumSize(new java.awt.Dimension(488, 507));
        mainPanel.setName("mainPanel"); // NOI18N

        labelLogo.setIcon(resourceMap.getIcon("labelLogo.icon")); // NOI18N
        labelLogo.setText(resourceMap.getString("labelLogo.text")); // NOI18N
        labelLogo.setAlignmentY(0.0F);
        labelLogo.setName("labelLogo"); // NOI18N
        labelLogo.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                labelLogoMouseClicked(evt);
            }
        });

        PanelMenu.setName("PanelMenu"); // NOI18N

        buttonStartSinglePlayer.setFont(resourceMap.getFont("buttonStartSinglePlayer.font")); // NOI18N
        buttonStartSinglePlayer.setText(resourceMap.getString("buttonStartSinglePlayer.text")); // NOI18N
        buttonStartSinglePlayer.setName("buttonStartSinglePlayer"); // NOI18N
        buttonStartSinglePlayer.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                buttonStartSinglePlayerActionPerformed(evt);
            }
        });

        buttonOptions.setText(resourceMap.getString("buttonOptions.text")); // NOI18N
        buttonOptions.setName("buttonOptions"); // NOI18N
        buttonOptions.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                buttonOptionsActionPerformed(evt);
            }
        });

        buttonHighscores.setText(resourceMap.getString("buttonHighscores.text")); // NOI18N
        buttonHighscores.setName("buttonHighscores"); // NOI18N
        buttonHighscores.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                buttonHighscoresActionPerformed(evt);
            }
        });

        buttonHelp.setText(resourceMap.getString("buttonHelp.text")); // NOI18N
        buttonHelp.setName("buttonHelp"); // NOI18N
        buttonHelp.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                buttonHelpActionPerformed(evt);
            }
        });

        buttonQuit.setText(resourceMap.getString("buttonQuit.text")); // NOI18N
        buttonQuit.setName("buttonQuit"); // NOI18N
        buttonQuit.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                buttonQuitActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout PanelMenuLayout = new javax.swing.GroupLayout(PanelMenu);
        PanelMenu.setLayout(PanelMenuLayout);
        PanelMenuLayout.setHorizontalGroup(
            PanelMenuLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(PanelMenuLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(PanelMenuLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(buttonStartSinglePlayer, javax.swing.GroupLayout.DEFAULT_SIZE, 168, Short.MAX_VALUE)
                    .addComponent(buttonOptions, javax.swing.GroupLayout.DEFAULT_SIZE, 168, Short.MAX_VALUE)
                    .addComponent(buttonHighscores, javax.swing.GroupLayout.DEFAULT_SIZE, 168, Short.MAX_VALUE)
                    .addComponent(buttonHelp, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, 168, Short.MAX_VALUE)
                    .addComponent(buttonQuit, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, 168, Short.MAX_VALUE))
                .addContainerGap())
        );
        PanelMenuLayout.setVerticalGroup(
            PanelMenuLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(PanelMenuLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(buttonStartSinglePlayer)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(buttonOptions)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(buttonHighscores)
                .addGap(18, 18, 18)
                .addComponent(buttonHelp)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(buttonQuit)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        jToggleButton1.setText(resourceMap.getString("jToggleButton1.text")); // NOI18N
        jToggleButton1.setName("jToggleButton1"); // NOI18N
        jToggleButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jToggleButton1ActionPerformed(evt);
            }
        });

        jToggleButton2.setText(resourceMap.getString("jToggleButton2.text")); // NOI18N
        jToggleButton2.setName("jToggleButton2"); // NOI18N
        jToggleButton2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jToggleButton2ActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout mainPanelLayout = new javax.swing.GroupLayout(mainPanel);
        mainPanel.setLayout(mainPanelLayout);
        mainPanelLayout.setHorizontalGroup(
            mainPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(mainPanelLayout.createSequentialGroup()
                .addGroup(mainPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(labelLogo)
                    .addGroup(mainPanelLayout.createSequentialGroup()
                        .addGap(134, 134, 134)
                        .addGroup(mainPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(PanelMenu, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addGroup(mainPanelLayout.createSequentialGroup()
                                .addGap(10, 10, 10)
                                .addGroup(mainPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                                    .addComponent(jToggleButton1, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                    .addComponent(jToggleButton2, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, 167, Short.MAX_VALUE))))))
                .addContainerGap())
        );
        mainPanelLayout.setVerticalGroup(
            mainPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(mainPanelLayout.createSequentialGroup()
                .addComponent(labelLogo)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(PanelMenu, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jToggleButton2)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jToggleButton1)
                .addGap(178, 178, 178))
        );

        setComponent(mainPanel);
    }// </editor-fold>//GEN-END:initComponents

    /* High scores button has been clicked, open high score window */
private void buttonHighscoresActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_buttonHighscoresActionPerformed
    (new HighScore(Application.getApplication().getMainFrame(), true)).setVisible(true);
}//GEN-LAST:event_buttonHighscoresActionPerformed
    /* Options button has been clicked, open options window */
private void buttonOptionsActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_buttonOptionsActionPerformed
    (new Options(Application.getApplication().getMainFrame(), true)).setVisible(true);
}//GEN-LAST:event_buttonOptionsActionPerformed
    /* Help button has been clicked, open help window */
private void buttonHelpActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_buttonHelpActionPerformed
    Help helpFrame = new Help();
    helpFrame.setVisible(true);
}//GEN-LAST:event_buttonHelpActionPerformed
    /* Exit button has been clicked, close application */
private void buttonQuitActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_buttonQuitActionPerformed
    Application.getApplication().exit();
}//GEN-LAST:event_buttonQuitActionPerformed
    /* Start game button has been clicked, initialize game and display game window */
private void buttonStartSinglePlayerActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_buttonStartSinglePlayerActionPerformed
    (new Game(Application.getApplication().getMainFrame(), true)).setVisible(true);
}//GEN-LAST:event_buttonStartSinglePlayerActionPerformed

    /* Toggle animations */
private void jToggleButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jToggleButton1ActionPerformed
    Game.noanimation = jToggleButton1.isSelected();
}//GEN-LAST:event_jToggleButton1ActionPerformed
    /* Toggle display of computer players in user lists */
private void jToggleButton2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jToggleButton2ActionPerformed
    Options.computerasuser = jToggleButton2.isSelected();
}//GEN-LAST:event_jToggleButton2ActionPerformed
    /* Logo has been clicked, when clicked 5 times test features are enabled */
private void labelLogoMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_labelLogoMouseClicked
    count++;
    if (count == 5) { 
        boolean b = jToggleButton1.isVisible();
        jToggleButton1.setVisible(!b);
        jToggleButton2.setVisible(!b);        
        count = 0;
    }
}//GEN-LAST:event_labelLogoMouseClicked

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JPanel PanelMenu;
    private javax.swing.JButton buttonHelp;
    private javax.swing.JButton buttonHighscores;
    private javax.swing.JButton buttonOptions;
    private javax.swing.JButton buttonQuit;
    private javax.swing.JButton buttonStartSinglePlayer;
    private javax.swing.JToggleButton jToggleButton1;
    private javax.swing.JToggleButton jToggleButton2;
    private javax.swing.JLabel labelLogo;
    private javax.swing.JPanel mainPanel;
    // End of variables declaration//GEN-END:variables
}
