/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package Game;
import ScoreManagement.User;
import GUI.*;
import AI.*;

/**
 *
 * @author s080440
 */
public class ComputerPlayer extends Player {

    public ComputerPlayer(Game game, User user, String color) {
        super(game, user,color);
    }
    

    /**
     * Calls the function to generate a move based on the difficulty level of the computer player. 
     * After obtaining the generated move, perform the move.
     */
    @Override
    public void doMove() {
        if (user.getDif() > 0) {
       putDisc( generateMove( user.getDif() ) );
        } else { 
            putDisc( generateMove( 1 ) );
            //putDisc ( (int) ( game.field.getWidth() * Math.random() ) );
        }
    }
   
    /**
     * Calls the minimax function 
     * @param diff The difficulty of the computer player.
     * @return The generated move by the minimax algorithm.
     */
    private int generateMove(int diff) {
        Tree tree = new Tree(diff, game.field.clone());
        return tree.minimaxAB(diff);
    }
}