/*
 * Player stores the information required for a single game.
 * The information consists off:
 * - User user
 * - String color [depends on player number]
 */
package Game;
import GUI.Game;
import ScoreManagement.User;

/**
 *
 * @author RJW Jonk
 */
public class Player {
    

    
    //variables
    public User user;  //store the user this player represents
    public String color; //store the color of the player
    public Game game;
    
    /**
     * @param game The game this player is associated with.
     * @param user The user this player is associated with.
     * @param color The color this player represents.
     */
    public Player(Game game, User user, String color) {
	this.game = game;
        this.user = user;
        this.color = color;
    }
    
    /**
     * Enable move
     */
    public void doMove() {}

    /**
     * Function to place a new disc in the playing field and to check if the move is done successfully.
     * @param c Column a new disc is played in.
     * @return True if the disc is placed in the field, false otherwise.
     */
    protected boolean putDisc(int c) {
	return game.field.putDisc(c, this);
    }
}
