/*
 * Gameresult is a container to store all the information of an user
 * It contains:
 * - The user identifier
 * - The name of the user
 * - A boolean which represents if the player is a computer
 * - The difficulty level:  for a computer from 0 <= level <= 5
 *                          for a human player: -1
 */
package ScoreManagement;

/**
 * Stores information about an User in the database
 */
public class User {
    // The information variables
    private int ID;
    private String name;
    private int difficulty;
    
    /**
     * Initializes the instance and sets the internal variables
     * @param ident ID number of this user
     * @param n1 Name of this user
     * @param dif Difficulty level for computer users, -1 for human users
     */
    User(int ident, String n1, int dif) {
        ID = ident;
        name = n1;
        difficulty = dif;
    }

    /* Get the ID number of this user */
    public int getID() {
        return ID;
    }

    /* Get the name of this user */
    public String getName() {
        return name;
    }

    /* Returns whether this user is a computer player */
    public boolean isComputer() {
        return (difficulty != -1);
    }

    /* Gets the difficulty level if this is a computer player, -1 otherwise */
    public int getDif() {
        return difficulty;
    }

    /* Returns a string representation of this instance, containing the name of the user */
    @Override public String toString() {
	return name;
    }
}
